# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.commit_metadata import CommitMetadata  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.global_id import GlobalId  # noqa: F401,E501


class Change(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'commit_metadata': 'CommitMetadata',
        'affected_global_id': 'GlobalId',
        'affected_local_id': 'object',
        'affected_object': 'object'
    }

    attribute_map = {
        'commit_metadata': 'commitMetadata',
        'affected_global_id': 'affectedGlobalId',
        'affected_local_id': 'affectedLocalId',
        'affected_object': 'affectedObject'
    }

    def __init__(self, commit_metadata=None, affected_global_id=None, affected_local_id=None, affected_object=None):  # noqa: E501
        """Change - a model defined in Swagger"""  # noqa: E501

        self._commit_metadata = None
        self._affected_global_id = None
        self._affected_local_id = None
        self._affected_object = None
        self.discriminator = None

        if commit_metadata is not None:
            self.commit_metadata = commit_metadata
        if affected_global_id is not None:
            self.affected_global_id = affected_global_id
        if affected_local_id is not None:
            self.affected_local_id = affected_local_id
        if affected_object is not None:
            self.affected_object = affected_object

    @property
    def commit_metadata(self):
        """Gets the commit_metadata of this Change.  # noqa: E501


        :return: The commit_metadata of this Change.  # noqa: E501
        :rtype: CommitMetadata
        """
        return self._commit_metadata

    @commit_metadata.setter
    def commit_metadata(self, commit_metadata):
        """Sets the commit_metadata of this Change.


        :param commit_metadata: The commit_metadata of this Change.  # noqa: E501
        :type: CommitMetadata
        """

        self._commit_metadata = commit_metadata

    @property
    def affected_global_id(self):
        """Gets the affected_global_id of this Change.  # noqa: E501


        :return: The affected_global_id of this Change.  # noqa: E501
        :rtype: GlobalId
        """
        return self._affected_global_id

    @affected_global_id.setter
    def affected_global_id(self, affected_global_id):
        """Sets the affected_global_id of this Change.


        :param affected_global_id: The affected_global_id of this Change.  # noqa: E501
        :type: GlobalId
        """

        self._affected_global_id = affected_global_id

    @property
    def affected_local_id(self):
        """Gets the affected_local_id of this Change.  # noqa: E501


        :return: The affected_local_id of this Change.  # noqa: E501
        :rtype: object
        """
        return self._affected_local_id

    @affected_local_id.setter
    def affected_local_id(self, affected_local_id):
        """Sets the affected_local_id of this Change.


        :param affected_local_id: The affected_local_id of this Change.  # noqa: E501
        :type: object
        """

        self._affected_local_id = affected_local_id

    @property
    def affected_object(self):
        """Gets the affected_object of this Change.  # noqa: E501


        :return: The affected_object of this Change.  # noqa: E501
        :rtype: object
        """
        return self._affected_object

    @affected_object.setter
    def affected_object(self, affected_object):
        """Sets the affected_object of this Change.


        :param affected_object: The affected_object of this Change.  # noqa: E501
        :type: object
        """

        self._affected_object = affected_object

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Change):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
